DSP         = $8000

            .code
            .export DSP_INIT
            .export DSP_PRBYTE
            .export DSP_PUTCH
            .export DSP_CLS
            .export DSP_NEWLINE

; Initialize LCD display, 16x02, undescore cursor
; ACC
INIT_SEQ:   .byte $30,$30,$30,$3C,$08,$01,$06,$02,$0E,$00
DSP_INIT:   LDX $FF
INIT_LOOP:  INX
            LDA INIT_SEQ,X
            STA DSP
            BNE INIT_LOOP

            STA DSP
            ; pause...
            STA DSP
            ; pause ...
            STA DSP
            ; 8 bit, 2 lines, font 5x10
            LDA #$3C
            STA DSP
            ; display off
            LDA #$08
            STA DSP
            ; display clear
            LDA #$01
            STA DSP
            ; entry mode set
            LDA #$06
            STA DSP
            ; scroll display
            ;LDA #$1C
            ;STA DSP
            ; home display
            ;LDA #$02
            ;STA DSP
            ; display on
            LDA #$0E
            STA DSP
            RTS

DSP_PRBYTE: PHA             ; Save A for LSD.
            LSR
            LSR
            LSR             ; MSD to LSD position.
            LSR
            JSR PRHEX       ; Output hex digit.
            PLA             ; Restore A.
PRHEX:      AND #$0F        ; Mask LSD for hex print.
            ORA #'0'        ; Add "0".
            CMP #$3A        ; Digit?
            BCC DSP_PUTCH   ; Yes, output it.
            CLC
            ADC #'A'-$0A-'0'; Add offset for letter.
; Put char on display
; ACC = char
DSP_PUTCH:  BIT DSP         ; bit (B7) cleared yet?
            BMI DSP_PUTCH   ; No, wait for display.
            STA DSP+1       ; Output character. Sets DA.
            RTS             ; Return.

DSP_CLS:    LDA #$01
            STA DSP
            RTS

DSP_NEWLINE:LDA #$C0
            STA DSP
            RTS